unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Button2: TButton;
    Timer1: TTimer;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure ImgeClear;
    procedure xyPlot_Line(xd, yd : double; MF: boolean);
    function input(var bcos, bsin: integer) : boolean;
    function triangle_wave(t, qt, ft: integer): double;
  public
    procedure Lissajous_curve(bcos, bsin, Q: integer);
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// C[WNA
procedure TForm1.ImgeClear;
var
  Rect : TRect;
begin
  Rect.Top := 0;
  Rect.Left := 0;
  Rect.Right := image1.Width;
  Rect.Bottom := image1.Height;
  image1.Canvas.Brush.Color := clWhite;
  image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.FillRect(Rect);
end;

// xd, yd  x, yW
// MF  true Lineto false  moveto
procedure TForm1.xyPlot_Line(xd, yd : double; MF: boolean);
var
  x, y: integer;
  xc, yc: integer;
  ps: double;
begin
  xc := image1.Width div 2;
  yc := image1.Height div 2;
  if xc < yc then ps := xc / 1.5 else ps := yc / 1.5;
  x := round(xd * ps) + xc;
  y := yc - round(yd * ps);
  if MF then image1.Canvas.LineTo(x, y)
        else image1.Canvas.MoveTo(x, y);
end;

// Opg
// t ʒu
// qt  s[Nʒu
// ft  
// result  -1`+1
function TForm1.triangle_wave(t, qt, ft: integer): double;
var
  n : integer;
begin
  result := 0;
  t := t mod ft;
  n := t div qt;
  case n of
    0 : result := t / qt;
    1 : result := (qt + qt - t) / qt;
    2 : result := - (t - qt - qt) / qt;
    3 : result := - (qt + qt + qt + qt - t) / qt
  end;
end;

const
  Period = 720;            // 

var
  bcos, bsin, Q: integer;  // bcos xg`  bsin yg`
                           // Q ɑ΂ʑ

// bcos, bsin  px{(}TCN)
// Q  sinʑp
procedure TForm1.Lissajous_curve(bcos, bsin, Q: integer);
var
  i, qt : integer;
  x, y, t, dt, sq :double;
begin
  ImgeClear;
  qt := Period div 4;
  dt := pi / Period * 2;
  sq := pi / 180 * Q;      // ʑp rad
  x := 0;
  y := 0;
  // n_ړ
  case radiogroup1.ItemIndex of
    0: x := cos(0);
    1: x := triangle_wave(0, qt, Period);
  end;
  case radiogroup2.ItemIndex of
    0: y := sin(sq);
    1: y := triangle_wave(Q, qt, Period);
  end;
  xyPlot_Line(x, y, false);
  // }
  for i := 1 to Period do begin
    t := dt * i;
    case radiogroup1.ItemIndex of
      0: x := cos(bcos * t);
      1: x := triangle_wave(bcos * i, qt, Period);
    end;
    case radiogroup2.ItemIndex of
      0: y := sin(bsin * t + sq);
      1: y := triangle_wave(bsin * i + Q, qt, Period);
    end;
    xyPlot_Line(x, y, true);
  end;
end;

// ^C}[[v
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Lissajous_curve(bcos, bsin, Q);
  inc(Q);
  if Q >= Period then Q := 0;
end;

// ͏
function TForm1.input(var bcos, bsin: integer) : boolean;
var
  ch : integer;
begin
  result := false;
  val(labelededit1.Text, bcos, ch);
  if ch <> 0 then begin
    application.MessageBox('cosWɊԈႢ܂B','',0);
    exit;
  end;
  val(labelededit2.Text, bsin, ch);
  if ch <> 0 then begin
    application.MessageBox('sinWɊԈႢ܂B','',0);
    exit;
  end;
  result := true;
end;

//  strat
procedure TForm1.Button1Click(Sender: TObject);
begin
  if not input(bcos, bsin) then exit;
  timer1.Enabled := true;
end;

// ~
procedure TForm1.Button2Click(Sender: TObject);
begin
  timer1.Enabled := false;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  timer1.Enabled := false;
  timer1.Interval := 30;
  Q := 0;
  ImgeClear;
  image1.Canvas.Pen.Color := clRed;
  image1.Canvas.Pen.Width := 2;
end;

end.
